var template = ''
$.ajax('../../../component/statistics/GxbManage/index.html', {
  data: {},
  dataType: 'html',
  cache: false,
  timeout: 60000,
  async: false,
  error: function (res) {},
  success: function (res) {
    template = res
  }
})

Vue.component('gxb-manage', {
  template: template,
  props: [],
  data: function () {
    return {
      years: [],
      yearType: '1',
      chooseYear: null,
      chooseTime: null,
      dialogExportLoading: false,
      rangeOptions: [
        { label: '区', value: 'town' },
        { label: '社区', value: 'hospital' },
        { label: '团队', value: 'team' }
      ],
      areaOptions: [
        { label: '思明区', value: '350203' },
        { label: '海沧区', value: '350205' },
        { label: '湖里区', value: '350206' },
        { label: '集美区', value: '350211' },
        { label: '同安区', value: '350212' },
        { label: '翔安区', value: '350213' }
      ],
      hospitalOptions: [],
      teamOptions: [],
      form: {
        range: 'town'
      },
      loading: false,
      exportLoading: false,
      tableData: [],
      constantHeader: [
        { label: '已评估人数', prop: 'totalNum', width: '90' },
        { label: '已上转人数', prop: 'turnUpNum', width: '90' },
        { label: '上转转门诊', prop: 'mzNum', width: '110' },
        { label: '门诊转住院', prop: 'zyNum', width: '110' },
        { label: '下转管理人数', prop: 'turnDownNum', width: '110' },
        { label: '评估已登记随访', prop: 'followUpNum', width: '110' }
        // { label: '随访已达标', prop: 'standardNum', width: '110' }
      ],
      tableHeader: [],
      loadingTwo: false,
      mzTableHeader: [
        { label: '姓名', prop: 'name', width: '90' },
        { label: '性别', prop: 'sex', width: '90' },
        { label: '年龄', prop: 'age', width: '90' },
        { label: '手机号', prop: 'mobile', width: '90' },
        { label: '证件号码', prop: 'idcard', width: '90' },
        { label: '社区医院', prop: 'signHospitalName', width: '90' },
        { label: '签约医生', prop: 'signDoctorName', width: '90' },
        { label: '最近一次上传时间', prop: 'czrq', width: '90' },
        { label: '最近一次上转科室', prop: 'deptName', width: '90' },
        { label: '最近一次门诊下转时间', prop: 'createTime', width: '90' },
        { label: '最近一次门诊下转诊断', prop: 'diagnosisName', width: '90' }
      ],
      mzToInHopistalTableHeader: [
        { label: '姓名', prop: 'name', width: '90' },
        { label: '性别', prop: 'sex', width: '90' },
        { label: '年龄', prop: 'age', width: '90' },
        { label: '手机号', prop: 'mobile', width: '90' },
        { label: '证件号码', prop: 'idcard', width: '90' },
        { label: '社区医院', prop: 'signHospitalName', width: '90' },
        { label: '签约医生', prop: 'signDoctorName', width: '90' },
        { label: '最近一次门诊下转时间', prop: 'mzCreateTime', width: '90' },
        { label: '最近一次门诊下转诊断', prop: 'mzDiagnosisName', width: '90' },
        { label: '最近一次出院下转时间', prop: 'zyCreateTime', width: '90' },
        { label: '最近一次出院下转诊断', prop: 'zyDiagnosisName', width: '90' }
      ],
      turnDownTableHeader: [
        { label: '姓名', prop: 'name', width: '90' },
        { label: '性别', prop: 'sex', width: '90' },
        { label: '年龄', prop: 'age', width: '90' },
        { label: '手机号', prop: 'mobile', width: '90' },
        { label: '最近一次下转医院', prop: 'hospitalName', width: '90' },
        { label: '最近一次下转医生', prop: 'hospitalDoctor', width: '90' },
        { label: '最近一次下转时间', prop: 'zyCreateTime', width: '90' },
        { label: '出院下转次数', prop: 'turnDownTimes', width: '90' },
        { label: '康复计划数量', prop: 'rehabilitationTimes', width: '90' }
      ],
      totalNumTableHeader: [
        { label: '姓名', prop: 'name' },
        { label: '性别', prop: 'sex' },
        { label: '年龄', prop: 'age' },
        { label: '评估结果', prop: 'screenResult' },
        { label: '评估医生', prop: 'doctorName' },
        { label: '评估时间', prop: 'czrq' },
        { label: '手机号', prop: 'mobile' },
        { label: '证件号码', prop: 'idcard' },
        { label: '签约社区', prop: 'signHospitalName' },
        { label: '签约医生', prop: 'signDoctorName' }
      ],
      turnUpNumTableHeader: [
        { label: '姓名', prop: 'name' },
        { label: '性别', prop: 'sex' },
        { label: '年龄', prop: 'age' },
        { label: '社区医院', prop: 'signHospitalName' },
        { label: '签约医生', prop: 'signDoctorName' },
        { label: '手机号', prop: 'mobile' },
        { label: '证件号码', prop: 'idcard' },
        { label: '预约医院', prop: 'orgName' },
        { label: '预约医生', prop: 'dName' },
        { label: '预约科室', prop: 'deptName' },
        { label: '预约时间', prop: 'orderTime' },
        { label: '数据来源', prop: 'sourceType' }
      ],
      dialogTableHeader: [],
      page: 1,
      size: 10,
      total: 0,
      level: 0,
      mzDialogVisible: false,
      query: {
        sex: ''
      },
      dataInfo: [],
      title: '',
      dataRangeOption: []
    }
  },
  methods: {
    gotoDetail(row, column) {
      if (!row.code) return
      var vm = this
      this.query = { sex: '' }
      switch (column) {
        case 'mzNum':
          vm.dialogTableHeader = vm.mzTableHeader
          this.title = '上转转门诊明细'
          break
        case 'zyNum':
          vm.dialogTableHeader = vm.mzToInHopistalTableHeader
          this.title = '门诊转住院明细'
          break
        case 'turnDownNum':
          vm.dialogTableHeader = vm.turnDownTableHeader
          this.title = '下转管理明细'
          break
        case 'totalNum':
          this.query = { sex: '', screenResultCode: '' }
          vm.dialogTableHeader = vm.totalNumTableHeader
          this.title = '个案数据列表'
          break
        case 'turnUpNum':
          vm.dialogTableHeader = vm.turnUpNumTableHeader
          this.title = '上转预约明细列表'
          break
      }
      var len = row.code.length
      if (len == 6) {
        this.query.range = 'town'
        this.query.area = row.code
      } else if (len == 10) {
        this.query.range = 'hospital'
        this.query.hospital = row.code
      } else {
        this.query.range = 'team'
        this.query.team = row.code
      }
      this.dataRangeOption = [{ label: row.name, value: row.code }]
      if (column == 'mzNum') {
        this.mzDialogVisible = true
        this.turnUpToMzDetailPage()
      } else if (column == 'turnDownNum' || column == 'zyNum') {
        this.mzDialogVisible = true
        this.turnDownManageDetailPage()
      } else if (column == 'totalNum') {
        this.mzDialogVisible = true
        this.gxbCaseDataPage()
      } else if (column == 'turnUpNum') {
        this.mzDialogVisible = true
        this.gxbTurnUpInfoPage()
      }
    },
    gxbTurnUpInfoPage() {
      var vm = this
      this.loadingTwo = true
      var params = JSON.parse(JSON.stringify(this.query))
      params.page = this.page
      params.pageSize = this.size
      vm.dataInfo = []
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      httpRequest.get('statistics/collaborate/gxbTurnUpInfoPage', { data: params }).then(function (res) {
        if (res.status == 200) {
          vm.dataInfo = res.detailModelList
          vm.total = res.totalCount
        }
        vm.loadingTwo = false
      })
    },
    gxbCaseDataPage() {
      var vm = this
      this.loadingTwo = true
      var params = JSON.parse(JSON.stringify(this.query))
      params.page = this.page
      params.pageSize = this.size
      vm.dataInfo = []
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      httpRequest.get('statistics/collaborate/gxbCaseDataPage', { data: params }).then(function (res) {
        if (res.status == 200) {
          vm.dataInfo = res.detailModelList
          vm.total = res.totalCount
        }
        vm.loadingTwo = false
      })
    },
    seePatientDetail(row, prop) {
      if (prop == 'name') {
        if (this.title == '上转预约明细列表') {
          EventBus.$emit('preview-person-info', { type: '2', code: row.code })
        } else if (this.title == '个案数据列表') {
          EventBus.$emit('preview-person-info', { type: '1', code: row.code })
        } else if (this.title == '上转转门诊明细') {
          EventBus.$emit('preview-person-info', { type: '3', code: row.code })
        } else if (this.title == '门诊转住院明细') {
          EventBus.$emit('preview-person-info', { type: '4', code: row.code })
        } else if (this.title == '下转管理明细') {
          EventBus.$emit('preview-person-info', { type: '5', code: row.code })
        }
      }
    },
    turnDownManageDetailPage() {
      var vm = this
      this.loadingTwo = true
      var url = ''
      var params = JSON.parse(JSON.stringify(this.query))
      vm.dataInfo = []
      params.page = this.page
      params.pageSize = this.size
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      if (this.title == '下转管理明细') {
        url = 'statistics/collaborate/turnDownManageDetailPage'
      } else if (this.title == '门诊转住院明细') {
        url = 'statistics/collaborate/mzToInHopistalDetailPage'
      }
      httpRequest.get(url, { data: params }).then(function (res) {
        if (res.status == 200) {
          vm.dataInfo = res.detailModelList
          vm.total = res.totalCount
        }
        vm.loadingTwo = false
      })
    },

    turnUpToMzDetailPage() {
      var vm = this
      this.loadingTwo = true
      var params = JSON.parse(JSON.stringify(this.query))
      params.page = this.page
      params.pageSize = this.size
      vm.dataInfo = []
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      httpRequest.get('statistics/collaborate/turnUpToMzDetailPage', { data: params }).then(function (res) {
        if (res.status == 200) {
          vm.dataInfo = res.detailModelList
          vm.total = res.totalCount
        }
        vm.loadingTwo = false
      })
    },
    closeDialog() {
      this.mzDialogVisible = false
    },
    dialogSearchFn() {
      this.page = 1
      if (this.title == '上转预约明细列表') {
        this.gxbTurnUpInfoPage()
      } else if (this.title == '上转转门诊明细' || this.title == '门诊转住院明细') {
        this.turnUpToMzDetailPage()
      } else if (this.title == '下转管理明细') {
        this.turnDownManageDetailPage()
      } else if (this.title == '个案数据列表') {
        this.gxbCaseDataPage()
      }
    },
    dialogExportFn() {
      this.dialogExportLoading = true
      var vm = this
      var params = {
        ...this.query
      }
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      if (this.title == '上转转门诊明细') {
        var fileName = `上转转门诊明细${new Date().getTime()}.xls`
        httpRequest.downLoadFileForAjax('statistics/collaborate/exportTurnUpToMzDetailPage', fileName, params).then(function () {
          vm.dialogExportLoading = false
        })
      } else if (this.title == '门诊转住院明细') {
        var fileName = `门诊转住院明细${new Date().getTime()}.xls`
        httpRequest.downLoadFileForAjax('statistics/collaborate/exportMzToInHopistalDetailPage', fileName, params).then(function () {
          vm.dialogExportLoading = false
        })
      } else if (this.title == '个案数据列表') {
        var fileName = `个案数据列表${new Date().getTime()}.xls`
        httpRequest.downLoadFileForAjax('statistics/collaborate/exportGxbCaseDataPage', fileName, params).then(function () {
          vm.dialogExportLoading = false
        })
      } else if (this.title == '上转预约明细列表') {
        var fileName = `上转预约明细列表${new Date().getTime()}.xls`
        httpRequest.downLoadFileForAjax('statistics/collaborate/exportGxbTurnUpInfoPage', fileName, params).then(function () {
          vm.dialogExportLoading = false
        })
      } else if (this.title == '下转管理明细') {
        var fileName = `下转管理明细${new Date().getTime()}.xls`
        httpRequest.downLoadFileForAjax('statistics/collaborate/exportGxbTurnUpInfoPage', fileName, params).then(function () {
          vm.dialogExportLoading = false
        })
      }
    },
    dialogReset() {
      var params = {
        ...this.query
      }
      if (this.title == '个案数据列表') {
        this.query = {
          sex: '',
          screenResultCode: '',
          range: typeof params.range == 'undefined' ? '' : params.range,
          area: typeof params.area == 'undefined' ? '' : params.area,
          hospital: typeof params.hospital == 'undefined' ? '' : params.hospital,
          team: typeof params.team == 'undefined' ? '' : params.team
        }
      } else {
        this.query = {
          sex: '',
          range: typeof params.range == 'undefined' ? '' : params.range,
          area: typeof params.area == 'undefined' ? '' : params.area,
          hospital: typeof params.hospital == 'undefined' ? '' : params.hospital,
          team: typeof params.team == 'undefined' ? '' : params.team
        }
      }
    },
    init() {
      var selectedRole = JSON.parse(sessionStorage.getItem('selectedRole'))
      if (selectedRole.code.indexOf('350200') > -1) {
        this.level = 1 //  市卫健委
        this.areaOptions = [
          { label: '思明区', value: '350203' },
          { label: '海沧区', value: '350205' },
          { label: '湖里区', value: '350206' },
          { label: '集美区', value: '350211' },
          { label: '同安区', value: '350212' },
          { label: '翔安区', value: '350213' }
        ]
      } else if (selectedRole.code.length == 6) {
        this.level = 2 // 区管理
        this.areaOptions = [{ label: selectedRole.name.substring(0, 3), value: selectedRole.code }]
        this.form = {
          range: 'town',
          area: selectedRole.code
        }
        this.getHospital(selectedRole.code)
      } else {
        this.level = 3 // 社区管理
        this.rangeOptions = [
          { label: '社区', value: 'hospital' },
          { label: '团队', value: 'team' }
        ]
        this.areaOptions = [{ label: selectedRole.name.substring(0, 3), value: selectedRole.code.substring(0, 6) }]
        this.hospitalOptions = [{ name: selectedRole.name, code: selectedRole.code }]
        this.form = {
          range: 'hospital',
          area: selectedRole.code.substring(0, 6),
          hospital: selectedRole.code
        }
        this.getTeam(selectedRole.code)
      }
      this.initTime()
      this.searchFn()
    },
    initTime() {
      var vm = this
      var now = new Date()

      vm.nowyear = vm.chooseYear = now.getFullYear()
      vm.years = []
      for (i = vm.nowyear; i >= 2013; i--) {
        vm.years.push(i)
      }
    },
    resetArea() {
      if (this.level == 1) {
        delete this.form.area
        delete this.form.hospital
        delete this.form.team
      } else if (this.level == 2) {
        delete this.form.hospital
        delete this.form.team
      } else {
        delete this.form.team
      }
    },
    load(row, treeNode, resolve) {
      var params = {}
      var len = row.code.length
      if (len == 6) {
        params.range = 'hospital'
        params.area = row.code
      } else if (len == 10) {
        params.range = 'team'
        params.hospital = row.code
      }
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      httpRequest.get('statistics/collaborate/gxbScreenClosedLoop', { data: params }).then(function (res) {
        if (res.status == 200) {
          var children = res.detailModelList.map(function (item) {
            var data = JSON.parse(JSON.stringify(item))
            if (len == 6) {
              data.areaCode = row.code
              data.hospital = item.name
              data.hasChildren = true
            } else if (len == 10) {
              data.hospitalCode = row.code
              data.team = item.name
            }
            return data
          })

          resolve(children)
        }
      })
    },
    searchFn() {
      var vm = this
      this.loading = true
      var params = {
        ...this.form,
        isTotal: 1
      }
      vm.tableData = []
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      if (this.form.range == 'town') {
        this.tableHeader = getTownHeader().concat(this.constantHeader)
      } else if (this.form.range == 'hospital') {
        this.tableHeader = getHospitalHeader().concat(this.constantHeader)
      } else {
        this.tableHeader = getTeamHeader().concat(this.constantHeader)
      }
      httpRequest.get('statistics/collaborate/gxbScreenClosedLoop', { data: params }).then(function (res) {
        vm.tableData = res.detailModelList.map(function (item) {
          var data = JSON.parse(JSON.stringify(item))
          if (vm.form.range == 'town') {
            data.town = item.name
            data.hasChildren = item.code && true
          } else if (vm.form.range == 'hospital') {
            data.hospital = item.name
            data.hasChildren = item.code && true
          } else if (vm.form.range == 'team') {
            data.team = item.name
          }
          return data
        })
        vm.loading = false
      })
    },
    queryDate() {
      this.page = 1
      this.searchFn()
    },
    exportTable() {
      var vm = this
      var params = {
        ...this.form
      }
      if (this.yearType == '1') {
        params.startDate = this.chooseYear + '-01-01'
        params.endDate = this.chooseYear + '-12-31'
      } else {
        if (this.chooseTime) {
          params.startDate = this.chooseTime[0]
          params.endDate = this.chooseTime[1]
        }
      }
      this.exportLoading = true
      var fileName = `冠心病管理全流程闭环情况${new Date().getTime()}.xls`
      httpRequest.downLoadFileForAjax('statistics/collaborate/exportGxbScreenClosedLoop', fileName, params).then(function () {
        vm.exportLoading = false
      })
    },
    eliminateClick() {
      var selectedRole = JSON.parse(sessionStorage.getItem('selectedRole'))
      if (this.level == 1) {
        this.form = {
          range: 'town'
        }
      } else if (this.level == 2) {
        this.form = {
          range: 'town',
          area: selectedRole.code
        }
        this.getHospital(selectedRole.code)
      } else {
        this.form = {
          range: 'hospital',
          area: selectedRole.code.substring(0, 6),
          hospital: selectedRole.code
        }
        this.getTeam(selectedRole.code)
      }
      this.yearType = '1'
      this.chooseYear = new Date().getFullYear()
      this.chooseTime = null
      this.$forceUpdate()
    },
    getHospital(code, flag = true) {
      var vm = this
      if (flag) {
        delete this.form.hospital
        delete this.form.team
      }
      var params = {
        type: 5,
        code: code
      }
      httpRequest.post('common/district', { data: params }).then(function (res) {
        vm.hospitalOptions = [{ code: '', name: '全部' }]
        vm.hospitalOptions = vm.hospitalOptions.concat(res.list)
      })
    },
    getTeam(code, flag = true) {
      var vm = this
      if (flag) {
        delete this.form.team
      }
      var params = {
        hospital: code,
        area: this.form.area
      }
      httpRequest.get('statisticsExport/teamList', { data: params }).then(function (res) {
        vm.teamOptions = [{ id: '', name: '全部' }]
        vm.teamOptions = vm.teamOptions.concat(res.data)
      })
    },
    handleCurrentChange(val) {
      this.page = val
      if (this.title == '上转预约明细列表') {
        this.gxbTurnUpInfoPage()
      } else if (this.title == '上转转门诊明细' || this.title == '门诊转住院明细') {
        this.turnUpToMzDetailPage()
      } else if (this.title == '下转管理明细') {
        this.turnDownManageDetailPage()
      } else if (this.title == '个案数据列表') {
        this.gxbCaseDataPage()
      } else if (this.title == '上转预约明细列表') {
        this.gxbTurnUpInfoPage()
      }
    },
    handleSizeChange(val) {
      this.size = val
      if (this.title == '上转预约明细列表') {
        this.gxbTurnUpInfoPage()
      } else if (this.title == '上转转门诊明细' || this.title == '门诊转住院明细') {
        this.turnUpToMzDetailPage()
      } else if (this.title == '下转管理明细') {
        this.turnDownManageDetailPage()
      } else if (this.title == '个案数据列表') {
        this.gxbCaseDataPage()
      } else if (this.title == '上转预约明细列表') {
        this.gxbTurnUpInfoPage()
      }
    },
    getData(data) {
      this.yearType = data.yearType
      this.form.range = data.range
      this.form.area = data.area

      this.form.hospital = data.hospital
      this.form.team = data.team

      if (this.yearType == 1) {
        this.chooseYear = data.time
      } else {
        this.chooseTime = data.time
      }
      if (this.form.hospital) {
        // 如果有社区code传过来就调社区医院列表接口
        this.getHospital(data.area, false)
      }
      if (this.form.team) {
        // 如果有团队code传过来就调团队列表接口
        this.getTeam(data.hospital, false)
      }
      this.searchFn()
    },
    renderHeader: function (h, item) {
      var label = item.column.label
      var column = item.column
      var tooltip = {
        '签约社区': '显示为该患者当前的签约社区医院名称',
        '社区医院': '显示为该患者当前的签约社区医院名称',
        '签约医院': '显示为该患者当前的签约社区医院名称',
        '签约医生': '显示为该患者当前的签约社区医生名称',
        '家庭医生': '显示为该患者当前的签约社区医生名称'
      }

      if (label == '签约社区' || label == '签约医生' || label == '签约医院' || label == '家庭医生' || label == '社区医院') {
        return [
          label,
          h(
            'el-tooltip',
            {
              props: {
                content: (function () {
                  return tooltip[label]
                })(),
                placement: 'top'
              }
            },
            [
              h('span', {
                class: {
                  'el-icon-question': true
                }
              })
            ]
          )
        ]
      } else {
        return [column.label]
      }
    }
  },
  mounted() {
    this.init()
  }
})
