var questionList = [
  {
    label: '（第一次）大便潜血阳性（使用试剂盒化验后填写结果）',
    type: 'radio',
    options: [
      {
        label: '阴性',
        value: '1'
      },
      {
        label: '阳性',
        value: '2'
      }
    ],
    field: 'isHigh1',
    required: true
  },
  {
    label: '（第二次）大便潜血阳性（第一次检查后7天再次复查，结果更准确，非必填）',
    type: 'radio',
    options: [
      {
        label: '阴性',
        value: '1'
      },
      {
        label: '阳性',
        value: '2'
      }
    ],
    field: 'isHigh2'
  },
  {
    label: '社区名称',
    type: 'input',
    field: 'belongCommunity',
    required: true
  },
  {
    label: '医生姓名',
    type: 'input',
    field: 'doctorName',
    required: true
  },
  {
    label: '医生电话',
    type: 'input',
    field: 'doctorPhoneNo',
    required: true
  },
  {
    label: '申请单号',
    type: 'input',
    field: 'applyNo'
  },
  {
    label: '用户姓名',
    type: 'input',
    field: 'userName',
    required: true
  },
  {
    label: '证件类型',
    type: 'input',
    field: 'idNoType',
    required: true
  },
  {
    label: '身份证号',
    type: 'input',
    field: 'idNo',
    required: true
  },
  {
    label: '手机',
    type: 'input',
    field: 'phoneNo',
    required: true
  },
  {
    label: '年龄',
    type: 'input',
    field: 'age',
    required: true
  },
  {
    label: '性别',
    type: 'radio',
    field: 'sex',
    required: true,
    options: [
      {
        label: '男',
        value: '1'
      },
      {
        label: '女',
        value: '2'
      }
    ]
  },
  {
    label: '户籍省市区',
    type: 'input',
    field: 'hujiAddress',
    required: true
  },
  {
    label: '户籍街道地址',
    type: 'input',
    field: 'hujiAddressJiedao',
    required: true
  },
  {
    label: '居住省市区',
    type: 'input',
    field: 'juzhuAddress',
    required: true
  },
  {
    label: '居住街道地址',
    type: 'input',
    field: 'juzhuAddressJiedao',
    required: true
  },
  {
    label: '婚姻状况',
    type: 'radio',
    options: [],
    field: 'isMerge',
    required: true
  },
  {
    label: '文化程度',
    type: 'radio',
    options: [],
    field: 'eduState',
    required: true
  },
  {
    label: '工作状况',
    type: 'radio',
    options: [],
    field: 'jobState',
    required: true
  },
  {
    label: '服用抗栓药物',
    type: 'radio',
    options: [
      {
        label: '有',
        value: '1'
      },
      {
        label: '无',
        value: '2'
      }
    ],
    field: 'isFuyongks',
    required: true
  },
  {
    label: '抗栓药物名称',
    type: 'checkbox',
    options: [],
    field: 'ksDrugName1'
  },
  {
    label: '抗栓药物其他名称',
    type: 'input',
    field: 'ksDrugName'
  },
  {
    label: '本人有癌症史',
    type: 'radio',
    field: 'isCancerHistory',
    options: [
      {
        label: '有',
        value: '1'
      },
      {
        label: '无',
        value: '2'
      },
      {
        label: '不详',
        value: '3'
      }
    ],
    required: true
  },
  {
    label: '癌症类型或名称',
    type: 'input',
    field: 'cancerType',
    required: true
  },
  {
    label: '是否做过胃肠镜检查',
    type: 'radio',
    field: 'isEndoscopy',
    required: true,
    options: [
      {
        label: '是',
        value: '1'
      },
      {
        label: '否',
        value: '2'
      },
    ]
  },
  {
    label: '做胃肠镜检查时间',
    type: 'input',
    field: 'endoscopyTime'
  },
  {
    label: '胃肠镜检查结果',
    type: 'input',
    field: 'endoscopyResult'
  },
  {
    label: '胃肠镜检查医院',
    type: 'input',
    field: 'endoscopyHospitalName'
  },
  {
    label: '本人有无肠息肉史',
    type: 'radio',
    field: 'isCxrHistory',
    required: true,
    options: [
      {
        label: '有',
        value: '1'
      },
      {
        label: '无',
        value: '2'
      },
      {
        label: '不详',
        value: '3'
      },
    ]
  },
  {
    label: '一级亲属有结直肠癌病史（如：父母、兄弟姐妹、子女）',
    type: 'radio',
    field: 'relativeAizHistory',
    required: true,
    options: [
      {
        label: '有',
        value: '1'
      },
      {
        label: '无',
        value: '2'
      },
      {
        label: '不详',
        value: '3'
      },
    ]
  },
  {
    label: '有无以下任意2项：慢性腹泻、慢性便秘、粘液血便、慢性阑尾炎或阑尾切除史、慢性胆囊炎或胆囊切除史、长期精神压抑',
    type:'radio',
    field: 'isMangxibing',
    required: true,
    options: [
    {
        label: '有',
        value: '1'
      },
      {
        label: '无',
        value: '2'
      },
      {
        label: '不详',
        value: '3'
      },
    ]
  },
  {
    label: '填写人签名',
    type:'input',
    field: 'signName',
    required: true
  },
  {
    label: '与被筛查人关系',
    type:'input',
    field: 'relations',
    required: true
  },
  {
    label: '申请时间',
    type:'input',
    field: 'createDate',
    required: true
  },
  {
    label: '钙卫蛋白结果（如无请忽略）',
    type:'radio',
    field: 'gwdbResult',
    options: [
      {
        label: '阴性',
        value: '1'
      },
      {
        label: '阳性',
        value: '2'
      }
    ]
  },
  {
    label: '是否医技检查',
    type:'input',
    field: 'isExam',
    required: true
  },
  {
    label: '评估结果',
    type:'radio',
    field: 'screenResult',
    required: true,
    options: [
      {
        label: '阴性',
        value: '1'
      },
      {
        label: '阳性',
        value: '2'
      }
    ]
  },
]